

     Public Shared Sub echotest(ByVal args As String())
     Dim conf As Config = New Config
	 ' configure sdk  
     conf.setCustomMaxLength(7, 0, 10)
     conf.setCustomType(7, 0, FType.NUMBER)
     
     conf.setCustomMaxLength(11, 0, 6)
     conf.setCustomType(11, 0, FType.NUMBER)

     conf.setCustomMaxLength(39, 0, 2)
     conf.setCustomType(39, 0, FType.TEXT)
          
     conf.setCustomMaxLength(70, 0, 3)
     conf.setCustomType(70, 0, FType.NUMBER)
     
     
     
     Dim isosdk As ISO8583II = New ISO8583II(conf)
     isosdk.setDebuglevel(3)
     isosdk.setOutput(System.Console.Out)
     Dim debug As Boolean = True
     Dim n As Integer = 10
     Dim port As Integer = 9000
     Try
       If Not (args Is Nothing) AndAlso args.Length > 1 Then
         n = com.a2zss.util.lib.toInt(args(1))
       End If
     Catch exl As Exception
       n = 1
     End Try
     Try
       If Not (args Is Nothing) AndAlso args.Length > 2 Then
         port = com.a2zss.util.lib.toInt(args(2))
       End If
     Catch exl As Exception
       port = 9000
     End Try
     Try
       If Not (args Is Nothing) AndAlso args.Length > 3 AndAlso "nodebug".Equals(args(3)) Then
         isosdk.setDebuglevel(0)
         isosdk.setOutput(Nothing)
         debug = False
       End If
     Catch exl As Exception
     End Try
     Dim start As Long = CType(System.DateTime.Now.ToFileTime, Long)
     Dim j As Integer = 0
     While j < n
       Dim message As Message = New Message
       Dim mti As ISOField = New ISOField(ISOField.F_MTI, "0800", conf)
       message.putISOField(mti)
       Dim b0 As Bitmap = New Bitmap(ISOField.F0_BITMAP0, conf)
       message.putISOField(b0)
		' second bitmap needed becuse of field 70 (if fields with number > 64)	
		' in your flex spec said that second bitmap will allways be there as they describe 128 bit bitmap
		' as single unit see page 16
       Dim b1 As Bitmap = New Bitmap(ISOField.F1_BITMAP1, conf)
       b0.setBit(ISOField.F1_BITMAP1, True)
       message.putISOField(b1)
       
	   Dim dateTime As ISOField = New ISOField(7, "0906092659", conf)
       b0.setBit(7, True)
       message.putISOField(dateTime)
       
       Dim stan As ISOField = New ISOField(ISOField.F11_STAN, "" & j, conf)
       b0.setBit(ISOField.F11_STAN, True)
       message.putISOField(stan)
       
       Dim nmic As ISOField = New ISOField(70, "301", conf)
       ' not field number is > 64 so set bit on second bitmap
       b1.setBit(70, True)
       message.putISOField(nmic)
       
       Dim data As Byte() = Nothing
       Dim s As System.Net.Sockets.Socket = Nothing
       Dim iss As System.IO.Stream = Nothing
       Dim oss As System.IO.Stream = Nothing
       Try
         
       		data = isosdk.formatLLLLPlain(message)
         ' if no message length needed use
         ' data = isosdk.formatPlain(message)
         
         If debug Then
           System.Console.Out.Write("The formatted message='")
           System.Console.Out.Write(com.a2zss.util.lib.toString(data))
           System.Console.Out.WriteLine("'")
           System.Console.Out.WriteLine
           s = New System.Net.Sockets.Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp)
           s.Connect(New System.Net.IPEndPoint(IPAddress.Parse("127.0.0.1"), port))
           iss = CType((New System.Net.Sockets.NetworkStream(s)), System.IO.Stream)
           oss = CType((New System.Net.Sockets.NetworkStream(s)), System.IO.Stream)
           oss.Write(data, 0, data.Length)
           oss.Flush
         End If
       Catch e As Exception
         System.Console.Out.WriteLine("There was error formatting message ")
         System.Console.Out.WriteLine(e.StackTrace)
       End Try
       Try
         Dim message2 As Message = New Message(isosdk.parseLLLLPlain(iss))
         ' if message length is not provided use
         ' message2 As Message = New Message(isosdk.parsePlain(iss))
         
         Dim i As Integer = -3
         While i < 128
           Dim isf As ISOField = CType(message.getISOField(i), ISOField)
           If Not (isf Is Nothing) AndAlso debug Then
             System.Console.Out.WriteLine("Found field " & i & "='" & isf.getStringValue & "'")
           End If
           System.Math.Min(System.Threading.Interlocked.Increment(i),i-1)
         End While
       Catch e As Exception
         System.Console.Out.WriteLine("There was error parsing message ")
         System.Console.Out.WriteLine(e.StackTrace)
       Finally
         If Not (oss Is Nothing) Then
           Try
             oss.Close
             oss = Nothing
           Catch dc As Exception
           End Try
         End If
         If Not (iss Is Nothing) Then
           Try
             iss.Close
             iss = Nothing
           Catch dc As Exception
           End Try
         End If
         If Not (s Is Nothing) Then
           Try
             s.Close
             s = Nothing
           Catch dc As Exception
           End Try
         End If
       End Try
       System.Math.Min(System.Threading.Interlocked.Increment(j),j-1)
     End While
     Dim endTs As Long = CType(System.DateTime.Now.ToFileTime, Long)
     System.Console.Out.WriteLine(n & " cycles done in " & ((endTs - start) / 10000) & " ms")
   End Sub